/*
 *  Assignment2.cpp
 *  OpenCV_Application
 *
 *  Created by Lee Seongwoo(2003721181) on 09. 03. 28.
 *  Dept. of Computer Science and Engineering
 *  Kwangwoon University(Seoul, Korea)
 *
 */

#include <stdio.h>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#pragma comment(lib, "cv.lib")   
#pragma comment(lib, "highgui.lib")   
#pragma comment(lib, "cxcore.lib") 

int main(void)
{
	IplImage* sourceImage = cvLoadImage("./sourceImage.png", CV_LOAD_IMAGE_COLOR);
	IplImage* sourceImageHSV = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 3);
	IplImage* sourceImageHue = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* sourceImageSaturation = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* sourceImageValue = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* sourceImageGray = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* maskImageHue = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* maskImageSaturation = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* maskImageValue = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* maskImage = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);
	IplImage* destinationImage = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 3);
	IplImage* tempImage = cvCreateImage(cvGetSize(sourceImage), IPL_DEPTH_8U, 1);

	char* sourceImageWindow = "Source Image Window";
	char* destinationImageWindow = "Converted Image Window";

	cvCvtColor(sourceImage, sourceImageHSV, CV_BGR2HSV);
	cvCvtColor(sourceImage, sourceImageGray, CV_BGR2GRAY);

	cvNamedWindow(sourceImageWindow);
	cvNamedWindow(destinationImageWindow);

	cvCvtPixToPlane(sourceImageHSV, sourceImageHue, sourceImageSaturation, sourceImageValue, NULL);

	cvInRangeS(sourceImageHue, cvScalar(0), cvScalar(18), maskImageHue);
	cvInRangeS(sourceImageSaturation, cvScalar(85), cvScalar(255), maskImageSaturation);
	cvInRangeS(sourceImageValue, cvScalar(60), cvScalar(256), maskImageValue);

	cvAnd(maskImageHue, maskImageSaturation, tempImage, NULL);
	cvAnd(tempImage, maskImageValue, maskImage, NULL);
	
	cvCvtColor(sourceImageGray, destinationImage, CV_GRAY2BGR);

	cvCopy(sourceImage, destinationImage, maskImage);

	cvShowImage(sourceImageWindow, sourceImage);
	cvShowImage(destinationImageWindow, destinationImage);

	cvWaitKey(0);

	cvReleaseImage(&sourceImage);
	cvReleaseImage(&sourceImageHSV);
	cvReleaseImage(&sourceImageHue);
	cvReleaseImage(&sourceImageSaturation);
	cvReleaseImage(&sourceImageValue);
	cvReleaseImage(&sourceImageGray);
	cvReleaseImage(&maskImageHue);
	cvReleaseImage(&maskImageSaturation);
	cvReleaseImage(&maskImageValue);
	cvReleaseImage(&maskImage);
	cvReleaseImage(&destinationImage);
	cvReleaseImage(&tempImage);

	cvDestroyAllWindows();

	return 0;
}